mklive.sh.in 13 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426
  1. #!/bin/bash
  2. #
  3. # vim: set ts=4 sw=4 et:
  4. #
  5. #-
  6. # Copyright (c) 2009-2013 Juan Romero Pardines.
  7. # All rights reserved.
  8. #
  9. # Redistribution and use in source and binary forms, with or without
  10. # modification, are permitted provided that the following conditions
  11. # are met:
  12. # 1. Redistributions of source code must retain the above copyright
  13. # notice, this list of conditions and the following disclaimer.
  14. # 2. Redistributions in binary form must reproduce the above copyright
  15. # notice, this list of conditions and the following disclaimer in the
  16. # documentation and/or other materials provided with the distribution.
  17. #
  18. # THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
  19. # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
  20. # OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
  21. # IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
  22. # INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
  23. # NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  24. # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
  25. # THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
  26. # (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
  27. # THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  28. #-
  29. set -E
  30. trap "echo; error_out $LINENO $?" INT TERM HUP ERR
  31. readonly PROGNAME=$(basename $0)
  32. info_msg() {
  33. printf "\033[1m$@\n\033[m"
  34. }
  35. error_out() {
  36. info_msg "There was an error in line $1 ... cleaning up $BUILDDIR, exiting."
  37. [ -d "$BUILDDIR" ] && rm -rf "$BUILDDIR"
  38. exit 1
  39. }
  40. write_etc_motd() {
  41. cat >> "$ROOTFS/etc/motd" <<_EOF
  42. ###############################################################################
  43. Autogenerated by void-mklive "@@MKLIVE_VERSION@@"
  44. ###############################################################################
  45. Welcome to the Void Linux Live system, you have been autologged in.
  46. This user has full sudo(8) permissions without any password, be careful
  47. executing commands through sudo(8).
  48. To start the installation please type:
  49. $ sudo void-installer
  50. and follow the on-screen instructions. Thanks for using Void Linux.
  51. http://www.voidlinux.eu
  52. ###############################################################################
  53. _EOF
  54. }
  55. write_conf_file() {
  56. cat > "$1" <<_EOF
  57. # *-*- sh -*-*
  58. # Default configuration file for vmklive-@VERSION@.
  59. #
  60. # List of packages to be installed into the live image.
  61. #
  62. # The 'base-system' package is always added to the generated image.
  63. #
  64. # To build an official live image add the following packages:
  65. # - dialog
  66. # - dracut-network
  67. # - dosfstools
  68. # - f2fs-tools
  69. # - grub-x86_64-efi
  70. # - parted
  71. PACKAGE_LIST="dialog dracut-network dosfstools f2fs-tools grub-x86_64-efi parted"
  72. # Default Void Linux splash image for grub/syslinux.
  73. SPLASH_IMAGE=/usr/share/void-artwork/splash.png
  74. # Default keymap to use.
  75. KEYMAP=us
  76. # Default locale to use.
  77. LOCALE=en_US.UTF-8
  78. # Path to XBPS utilities.
  79. #XBPS_INSTALL_CMD=xbps-install
  80. #XBPS_QUERY_CMD=xbps-query
  81. #XBPS_RECONFIGURE_CMD=xbps-reconfigure
  82. #XBPS_REMOVE_CMD=xbps-remove
  83. #XBPS_RINDEX_CMD=xbps-rindex
  84. #XBPS_UHELPER_CMD=xbps-uhelper
  85. # XBPS cache directory to install packages from.
  86. #REPOSITORY_CACHE=/blah/foo
  87. _EOF
  88. chmod 644 "$1"
  89. }
  90. usage() {
  91. cat <<_EOF
  92. Usage: $(basename $0) [options]
  93. Options:
  94. -C file Path to configuration file (defaults to ~/.mklive.conf)
  95. -c (gzip|bzip2|xz) Compression type for the initramfs/squashfs image.
  96. -r rootdir Use this directory to generate the image (if unset, defaults to cwd).
  97. -o outfile Output file name for the ISO image.
  98. -s splash Splash image file for isolinux.
  99. -V Show version.
  100. _EOF
  101. exit 1
  102. }
  103. install_packages() {
  104. for f in ${PACKAGE_LIST}; do
  105. info_msg " $f"
  106. done
  107. # Check that all pkgs are reachable.
  108. ${XBPS_INSTALL_CMD} ${XBPS_ARGS} -n ${PACKAGE_LIST} >>$LOGFILE 2>&1
  109. if [ $? -ne 0 ]; then
  110. info_msg "Missing required binary packages, exiting..."
  111. error_out
  112. fi
  113. ${XBPS_INSTALL_CMD} ${XBPS_ARGS} ${PACKAGE_LIST} >>$LOGFILE 2>&1
  114. ${XBPS_INSTALL_CMD} ${XBPS_ARGS} -u >>$LOGFILE 2>&1
  115. ${XBPS_REMOVE_CMD} ${XBPS_ARGS} -o >>$LOGFILE 2>&1
  116. ${XBPS_QUERY_CMD} -r "$ROOTFS" -l | sort > "${OUTPUT_FILE%.iso}"-package-list.txt
  117. # Enable choosen UTF-8 locale and generate it into the target rootfs.
  118. sed -e "s/\#\(${LOCALE}.*\)/\1/g" -i $ROOTFS/etc/default/libc-locales
  119. systemd-nspawn -D $ROOTFS xbps-reconfigure -fa >>$LOGFILE 2>&1
  120. # Enable some services if found.
  121. if [ -f $ROOTFS/usr/lib/systemd/system/NetworkManager.service ]; then
  122. systemd-nspawn -D $ROOTFS systemctl enable NetworkManager.service >>$LOGFILE 2>&1
  123. fi
  124. install -Dm755 /usr/sbin/void-installer $ROOTFS/usr/sbin/void-installer
  125. }
  126. generate_initramfs() {
  127. # Install required pkgs in a temporary rootdir to create
  128. # the initramfs and to copy required files.
  129. $XBPS_INSTALL_CMD -r $ROOTFS/kernel_temp -Sy \
  130. base-system void-mklive -c $REPOSITORY_CACHE >>$LOGFILE 2>&1
  131. systemd-nspawn -D $ROOTFS/kernel_temp /usr/bin/dracut --${COMPRESSTYPE} \
  132. --force-add "vmklive" "/boot/initrd.lz" $KERNELVERSION >>$LOGFILE 2>&1
  133. mv $ROOTFS/kernel_temp/boot/initrd.lz $BOOT_DIR
  134. cp $ROOTFS/kernel_temp/boot/vmlinuz-$KERNELVERSION $BOOT_DIR/vmlinuz
  135. rm -rf $ROOTFS/kernel_temp
  136. }
  137. generate_isolinux_boot() {
  138. cp -f $SYSLINUX_DATADIR/isolinux.bin "$ISOLINUX_DIR"
  139. cp -f $SYSLINUX_DATADIR/ldlinux.c32 "$ISOLINUX_DIR"
  140. cp -f $SYSLINUX_DATADIR/libcom32.c32 "$ISOLINUX_DIR"
  141. cp -f $SYSLINUX_DATADIR/vesamenu.c32 "$ISOLINUX_DIR"
  142. cp -f $SYSLINUX_DATADIR/libutil.c32 "$ISOLINUX_DIR"
  143. cp -f $SYSLINUX_DATADIR/chain.c32 "$ISOLINUX_DIR"
  144. cp -f $MKLIVE_DATADIR/isolinux.cfg.in \
  145. "$ISOLINUX_DIR"/isolinux.cfg
  146. if [ -f "$SPLASH_IMAGE" ]; then
  147. cp -f $SPLASH_IMAGE "$ISOLINUX_DIR"
  148. fi
  149. sed -i -e "s|@@SPLASHIMAGE@@|$(basename $SPLASH_IMAGE)|" \
  150. -e "s|@@KERNVER@@|${KERNELVERSION}|" \
  151. -e "s|@@KEYMAP@@|${KEYMAP}|" \
  152. -e "s|@@ARCH@@|$(uname -m)|" \
  153. -e "s|@@LOCALE@@|${LOCALE}|" $ISOLINUX_DIR/isolinux.cfg
  154. }
  155. generate_grub_efi_boot() {
  156. cp -f $MKLIVE_DATADIR/grub.cfg $GRUB_DIR
  157. cp -f $MKLIVE_DATADIR/grub_void.cfg.in $GRUB_DIR/grub_void.cfg
  158. sed -i -e "s|@@SPLASHIMAGE@@|$(basename $SPLASH_IMAGE)|" \
  159. -e "s|@@KERNVER@@|${KERNELVERSION}|" \
  160. -e "s|@@KEYMAP@@|${KEYMAP}|" \
  161. -e "s|@@ARCH@@|$(uname -m)|" \
  162. -e "s|@@LOCALE@@|${LOCALE}|" $GRUB_DIR/grub_void.cfg
  163. mkdir -p $GRUB_DIR/fonts
  164. cp -f $GRUB_DATADIR/unicode.pf2 $GRUB_DIR/fonts
  165. # Create EFI vfat image.
  166. dd if=/dev/zero of=$GRUB_DIR/efiboot.img bs=1024 count=4096 >>$LOGFILE 2>&1
  167. mkfs.vfat -F12 -S 512 -n "grub_uefi" "$GRUB_DIR/efiboot.img" >>$LOGFILE 2>&1
  168. GRUB_EFI_TMPDIR="$(mktemp --tmpdir=$HOME -d)"
  169. LOOP_DEVICE="$(losetup --show --find ${GRUB_DIR}/efiboot.img)"
  170. mount -o rw,flush -t vfat "${LOOP_DEVICE}" "${GRUB_EFI_TMPDIR}" >>$LOGFILE 2>&1
  171. mkdir -p "${GRUB_EFI_TMPDIR}/EFI/boot/"
  172. cd "$BUILDDIR"
  173. grub-mkstandalone --directory="/usr/lib/grub/x86_64-efi" \
  174. --format="x86_64-efi" \
  175. --compression="xz" --output="${GRUB_EFI_TMPDIR}/EFI/boot/bootx64.efi" \
  176. "boot/grub/grub.cfg" >>$LOGFILE 2>&1
  177. umount "$GRUB_EFI_TMPDIR"
  178. losetup --detach "${LOOP_DEVICE}"
  179. rm -rf $GRUB_EFI_TMPDIR
  180. }
  181. generate_squashfs() {
  182. # Find out required size for the rootfs and create an ext3fs image off it.
  183. ROOTFS_SIZE=$(du -sk "$ROOTFS"|awk '{print $1}')
  184. mkdir -p "$BUILDDIR/tmp/LiveOS"
  185. dd if=/dev/zero of="$BUILDDIR/tmp/LiveOS/ext3fs.img" \
  186. bs="$((${ROOTFS_SIZE}+($ROOTFS_SIZE/6)))K" count=1 >>$LOGFILE 2>&1
  187. mkdir -p "$BUILDDIR/tmp-rootfs"
  188. mkfs.ext3 -F -m1 "$BUILDDIR/tmp/LiveOS/ext3fs.img" >>$LOGFILE 2>&1
  189. mount -o loop "$BUILDDIR/tmp/LiveOS/ext3fs.img" "$BUILDDIR/tmp-rootfs"
  190. cd $BUILDDIR
  191. cp -a rootfs/* tmp-rootfs/
  192. umount -f "$BUILDDIR/tmp-rootfs"
  193. mkdir -p "$BUILDDIR/LiveOS"
  194. mksquashfs "$BUILDDIR/tmp" "$BUILDDIR/LiveOS/squashfs.img" \
  195. -comp ${COMPRESSTYPE} >>$LOGFILE 2>&1
  196. chmod 444 "$BUILDDIR/LiveOS/squashfs.img"
  197. # Remove rootfs and temporary dirs, we don't need them anymore.
  198. rm -rf "$ROOTFS" "$BUILDDIR/tmp-rootfs" "$BUILDDIR/tmp"
  199. }
  200. generate_iso_image() {
  201. xorriso -as mkisofs \
  202. -iso-level 3 -rock -joliet \
  203. -max-iso9660-filenames -omit-period \
  204. -omit-version-number -relaxed-filenames -allow-lowercase \
  205. -volid "VOID_LIVE" \
  206. -eltorito-boot boot/isolinux/isolinux.bin \
  207. -eltorito-catalog boot/isolinux/boot.cat \
  208. -no-emul-boot -boot-load-size 4 -boot-info-table \
  209. -eltorito-alt-boot -e boot/grub/efiboot.img -isohybrid-gpt-basdat -no-emul-boot \
  210. -isohybrid-mbr $SYSLINUX_DATADIR/isohdpfx.bin \
  211. -output "$OUTPUT_FILE" "$BUILDDIR" >>$LOGFILE 2>&1
  212. }
  213. #
  214. # main()
  215. #
  216. while getopts "C:c:o:r:s:hV" opt; do
  217. case $opt in
  218. C) CONFIG_FILE="$OPTARG";;
  219. c) COMPRESSTYPE="$OPTARG";;
  220. o) OUTPUT_FILE="$OPTARG";;
  221. r) ROOTDIR="$OPTARG";;
  222. s) SPLASH_IMAGE="$OPTARG";;
  223. h) usage;;
  224. V) echo "$PROGNAME @@MKLIVE_VERSION@@"; exit 0;;
  225. esac
  226. done
  227. shift $(($OPTIND - 1))
  228. # Set defaults
  229. if [ -z "$CONFIG_FILE" ]; then
  230. CONFIG_FILE="$HOME/.mklive.conf"
  231. fi
  232. LOGFILE="$(mktemp -t vmklive-XXXXXXXXXX.log)"
  233. if [ -z "$SYSLINUX_DATADIR" ]; then
  234. SYSLINUX_DATADIR=/usr/share/syslinux
  235. fi
  236. if [ -z "$GRUB_DATADIR" ]; then
  237. GRUB_DATADIR=/usr/share/grub
  238. fi
  239. if [ -z "$MKLIVE_DATADIR" ]; then
  240. MKLIVE_DATADIR=/usr/share/void-mklive
  241. fi
  242. if [ -z "$SPLASH_IMAGE" ]; then
  243. SPLASH_IMAGE=/usr/share/void-artwork/splash.png
  244. fi
  245. if [ -z "$XBPS_INSTALL_CMD" ]; then
  246. XBPS_INSTALL_CMD=xbps-install
  247. fi
  248. if [ -z "$XBPS_REMOVE_CMD" ]; then
  249. XBPS_REMOVE_CMD=xbps-remove
  250. fi
  251. if [ -z "$XBPS_QUERY_CMD" ]; then
  252. XBPS_QUERY_CMD=xbps-query
  253. fi
  254. if [ -z "$XBPS_RINDEX_CMD" ]; then
  255. XBPS_RINDEX_CMD=xbps-rindex
  256. fi
  257. if [ -z "$XBPS_UHELPER_CMD" ]; then
  258. XBPS_UHELPER_CMD=xbps-uhelper
  259. fi
  260. if [ -z "$XBPS_RECONFIGURE_CMD" ]; then
  261. XBPS_RECONFIGURE_CMD=xbps-reconfigure
  262. fi
  263. if [ -z "$COMPRESSTYPE" ]; then
  264. COMPRESSTYPE=xz
  265. fi
  266. if [ -z "$REPOSITORYCACHE" ]; then
  267. REPOSITORY_CACHE="/var/cache/xbps"
  268. fi
  269. # Create or read configuration file.
  270. if [ ! -r $CONFIG_FILE ]; then
  271. info_msg "Creating config file at $CONFIG_FILE."
  272. write_conf_file $CONFIG_FILE
  273. fi
  274. . $CONFIG_FILE
  275. if [ -z "$PACKAGE_LIST" ]; then
  276. PACKAGE_LIST="base-system"
  277. else
  278. PACKAGE_LIST="base-system $PACKAGE_LIST"
  279. fi
  280. if [ ! -f $SYSLINUX_DATADIR/isolinux.bin ]; then
  281. echo "Missing required isolinux files in $SYSLINUX_DATADIR, exiting..."
  282. exit 1
  283. fi
  284. # Check for root permissions.
  285. if [ "$(id -u)" -ne 0 ]; then
  286. echo "Must be run as root, exiting..."
  287. exit 1
  288. fi
  289. ISO_VOLUME="VOID_LIVE"
  290. if [ -n "$ROOTDIR" ]; then
  291. BUILDDIR=$(mktemp --tmpdir="$ROOTDIR" -d)
  292. else
  293. BUILDDIR=$(mktemp --tmpdir="$(pwd -P)" -d)
  294. fi
  295. BUILDDIR=$(readlink -f $BUILDDIR)
  296. ROOTFS="$BUILDDIR/rootfs"
  297. BOOT_DIR="$BUILDDIR/boot"
  298. ISOLINUX_DIR="$BOOT_DIR/isolinux"
  299. GRUB_DIR="$BOOT_DIR/grub"
  300. ISOLINUX_CFG="$ISOLINUX_DIR/isolinux.cfg"
  301. mkdir -p $ISOLINUX_DIR $GRUB_DIR
  302. #
  303. # Check there are repos registered before anything.
  304. #
  305. ${XBPS_QUERY_CMD} -L >/dev/null 2>&1
  306. if [ $? -ne 0 ]; then
  307. echo "No repositories available, exiting..."
  308. error_out
  309. fi
  310. XBPS_ARGS="-r $ROOTFS -y"
  311. XBPS_ARGS="$XBPS_ARGS -c $REPOSITORY_CACHE"
  312. XBPS_VERSION=$($XBPS_QUERY_CMD -V|awk '{print $2}')
  313. case $XBPS_VERSION in
  314. # XBPS >= 0.21
  315. [0-9].[2-9][1-9]*) ;;
  316. *) echo "Your xbps utilities are too old ($XBPS_VERSION), 0.21 is required."; exit 1;;
  317. esac
  318. # Sync index for remote repos first.
  319. $XBPS_INSTALL_CMD -r $ROOTFS -S >/dev/null 2>&1
  320. _linux_series=$($XBPS_QUERY_CMD -r $ROOTFS -Rx linux)
  321. KERNELVERSION=$($XBPS_QUERY_CMD -r $ROOTFS -R --property version ${_linux_series})
  322. if [ -z "$OUTPUT_FILE" ]; then
  323. OUTPUT_FILE="$HOME/void-live-$(uname -m)-${KERNELVERSION}-$(date +%Y%m%d).iso"
  324. fi
  325. info_msg "Redirecting stdout/stderr to $LOGFILE ..."
  326. #
  327. # Install live system and specified packages.
  328. #
  329. info_msg "[1/7] Installing packages into the rootfs..."
  330. install_packages
  331. #
  332. # Prepare /etc/motd.
  333. #
  334. mkdir -p "$ROOTFS"/etc
  335. write_etc_motd
  336. #
  337. # Generate the initramfs.
  338. #
  339. info_msg "[2/7] Generating initramfs image ($COMPRESSTYPE)..."
  340. generate_initramfs
  341. #
  342. # Generate the isolinux boot.
  343. #
  344. info_msg "[3/7] Generating isolinux support for PC-BIOS systems..."
  345. generate_isolinux_boot
  346. #
  347. # Generate the GRUB EFI boot.
  348. #
  349. info_msg "[4/7] Generating GRUB support for EFI systems..."
  350. generate_grub_efi_boot
  351. #
  352. # Generate the squashfs image from rootfs.
  353. #
  354. info_msg "[5/7] Generating squashfs image ($COMPRESSTYPE) from rootfs..."
  355. generate_squashfs
  356. #
  357. # Generate the ISO image.
  358. #
  359. info_msg "[6/7] Generating ISO image..."
  360. generate_iso_image
  361. info_msg "[7/7] Removing build directory..."
  362. rm -rf "$BUILDDIR"
  363. hsize=$(du -sh "$OUTPUT_FILE"|awk '{print $1}')
  364. info_msg "Created $(readlink -f $OUTPUT_FILE) ($hsize) successfully."
  365. exit 0